## 关于 I10n 配置
在本文件夹下存放了语言设置文件 `_l10nconfig.json` 以及所有的语言文件。

### 语言设置文件
语言设置文件用于程序自动加载所有有效的语言，段结构如下：
~~~
{
    "value": "zh-CN",
    "lang": "zh-CN",
    "name": "中文（简体）",
    "fallback": "zh-TW"
}
~~~
- `value`：语言名称。这只是在内部用于区分语言的名称，请保证它唯一，同时其对应的文件名应该相同。
- `lang`：语言地区。这个参数用于判断语言实际的地区，将会影响到时间金额等参数的格式化，请依照语种名称代码规范命名。
- `name`：显示名称。这是这个语言在语言设置选项中显示的名字。
- `fallback`：回退语言名称（不必填）。在翻译缺失的情况下，默认将会回退显示为 zh-CN，如果你有特殊的回退需求可以在此处指定回退到某个语言。

### 添加新的语言
添加新语言的方式很简单，首先在语言设置文件中追加相关设置，然后在文件夹中放入对应的翻译文件 `.json`，重新启动项目即可。

### 关于特殊的格式化和保留内容
#### 参数 `{*}`
- 这是参数，从程序中生成的参数将替换这个字符。如：`"join_time": "{time} 加入群聊"`
#### 复数 `|`
- 某些语言复数拥有特殊的格式，在可能出现复数的情况下将会像这样编写翻译：`"car": "car | cars"`